#!/bin/sh
### BEGIN INIT INFO
# Provides:          bukkit-daemon
# Required-Start:    $local_fs $remote_fs $network
# Required-Stop:     $local_fs $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Start or stop the bukkit-daemon.
### END INIT INFO

PKG_NAME="bukkit"
PKG_DIR=/usr/local/AppCentral/bukkit
RUN_AS="admin:administrators"
DAEMON="/usr/local/bin/java"
DAEMON_OPTS=" -Xms32M -Xmx512M -jar craftbukkit.jar nogui 2>&1"
BSPATH="/volume1/Public/bukkit_server" 

StartPkg(){ #starts the PKG
	/bin/echo -n "Starting $PKG_NAME"
	/bin/chown -R $RUN_AS $PKG_DIR
	/bin/chmod -R -t $PKG_DIR # make sure no system bits are set.
	/bin/chmod -R -s $PKG_DIR # make sure no system bits are set.
	[ -L $BSPATH ] && /bin/rm $BSPATH
	[ -d $BSPATH ] || /bin/mv $PKG_DIR/server $BSPATH
	[ -d $PKG_DIR/server ] && /bin/mv -f $PKG_DIR/server/* $BSPATH && /bin/rm $PKG_DIR/server
	cd $BSPATH
	[ -f $BSPATH/craftbukkit.jar ] || wget --no-check-certificate http://dl.bukkit.org/latest-rb/craftbukkit.jar
	/bin/chown -R $RUN_AS $MCPATH
	/sbin/start-stop-daemon -S -b -n bukkit -c $RUN_AS -x ${DAEMON} --${DAEMON_OPTS}
	/bin/echo " Done ($(/bin/date))"
}

ShutdownPkg() { #kills a proces based on a PID in a given PID file
	output=`ps aux|grep bukkit`
	set -- $output
	Pid=$1
	i=0
	/bin/kill $Pid
	/bin/echo -n " Waiting for ${PKG_NAME} to shut down: "
	while [ -d /proc/$Pid ]; do
		sleep 1
		let i+=1
		/bin/echo -n "$i, "
		if [ $i = 45 ]; then
			/bin/echo -n " Tired of waiting, killing ${PKG_NAME} now"
			/bin/kill -9 $Pid
			/bin/rm -f $PID_FILE
			/bin/echo " Done ($(/bin/date))"
			exit 1
		fi
	done
	/bin/echo "Done ($(/bin/date))"
}

case "$1" in
	start)	
		StartPkg	 
	;;
	stop)
		/bin/echo "Shutting down ${PKG_NAME} at $(/bin/date)... "
		ShutdownPkg 	#shutdown the package
	;;
	restart)
		echo "Restarting $PKG_NAME"
		ShutdownPkg
		StartPkg
	;;
	*)
		echo "Usage: $0 {start|stop|restart}"
esac

exit 0

